using e_suite.UnitTestCore;
using eSuite.API.Controllers;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Moq;
using System.Security.Claims;
using e_suite.API.Common;

namespace eSuite.API.UnitTests.Controllers.OrganisationControllerUnitTests;

public abstract class OrganisationControllerTestBase : TestBase
{
    protected Mock<IOrganisationsManager> _organisationManagerMock = null!;
    protected OrganisationsController _organisationController = null!;

    public override async Task Setup()
    {
        await base.Setup();
        _organisationManagerMock = new Mock<IOrganisationsManager>();
        _organisationController = new OrganisationsController(_organisationManagerMock.Object);

        const long id = -1;
        const string email = "email@mail.test";
        const string displayName = "Test Test";

        AddAuthorisedUserToController(id, email, displayName);
    }

    protected void AddAuthorisedUserToController(long id, string email, string displayName)
    {
        var user = new ClaimsPrincipal(new ClaimsIdentity(new Claim[]
        {
            new(ClaimTypes.PrimarySid, id.ToString()),
            new(ClaimTypes.Email, email),
            new(ClaimTypes.Name, displayName)
            // other required and custom claims
        }, "TestAuthentication"));

        _organisationController.ControllerContext = new ControllerContext
        {
            HttpContext = new DefaultHttpContext { User = user }
        };
    }
}